function test_1(num)
{
    return parseInt(num,16).toString(2).split('').reverse().splice(0,6);
}
function test_2(num)
{
    return parseInt(num,16).toString(2).split('').reverse();
}
function test_3(num)
{
    var dec = parseInt(num,16).toString(2);
    var c = 8-dec.length;
    if(c>0)
    {
        for(var i=0;i<c;i++)
        {
            dec='0'+dec;
        }
    }
    return dec.split('').reverse();
}
function test_4(num)
{
    var dec = parseInt(num,16).toString(2);
    var c = 8-dec.length;
    if(c>0)
    {
        for(var i=0;i<c;i++)
        {
            dec='0'+dec;
        }
    }
    return dec.split('').reverse().splice(0,6);
}
function get_time_zone()
{
    return new Date().getTimezoneOffset()*60*-1;
}
function convert_time(date)
{
    return date+get_time_zone();
}
class vega_converter
{
    constructor(){}
    round_size(num,decimal)
    {
        if(decimal==undefined||decimal<=0)
        {
            decimal = 1;
        }
        var decimal = Math.pow(10,decimal);
        return(Math.round(num*decimal)/decimal);
    }
}
class command_list
 {
     constructor()
    {
       this.get_users=false;
       this.manage_users=false;
       this.delete_users=false;
       this.get_device_appdata=false;
       this.get_data=false;
       this.send_data=false;
       this.manage_device_appdata=false;
       this.delete_device_appdata=false;
       this.get_gateways=false;
       this.manage_gateways=false;
       this.delete_gateways=false;
       this.get_devices=false;
       this.manage_devices=false;
       this.delete_devices=false;
       this.get_coverage_map=false;
       this.get_device_downlink_queue=false;
       this.manage_device_downlink_queue=false;
    }
    selectAll()
    {
        var valid = new valid_data();
        for(var key in this)
        {
            if(valid.isBool(this[key]))
            {
                this[key]=true;
            }
        }
    }
    unselectAll()
    {
        var valid = new valid_data();
        for(var key in this)
        {
            if(valid.isBool(this[key]))
            {
                this[key]=false;
            }
        }
    }
    set_patterns(pattern)
    {
        var valid = new valid_data();
        for(var key in pattern)
        {
            if(pattern[key]!=undefined&&valid.isBool(pattern[key])&&this[key]!=undefined&&valid.isBool(this[key]))
            {
                this[key]=pattern[key];
            }
        }
    }
    set_command_list_array(c_list)
    {
        var valid = new valid_data();
        if(c_list!=undefined&&c_list.length>0)
        {
            for(var i = 0 ; i<c_list.length;i++)
            {
                if(this[c_list[i]]!=undefined&&valid.isBool(this[c_list[i]]))
                {
                    this[c_list[i]]=true;
                }
            }  
        }
    }
    get_command_list_array()
    {
        var valid = new valid_data();
        var temp_array=[];
        for(var key in this)
        {
            if(valid.isBool(this[key]))
            {
                temp_array.push(key);
            }
        }
        return temp_array;
    }
 }
class sticky
{
    constructor()
    {
        this.general_info = true;
        this.summary_info = true;
        this.chart_consum = false;
        this.chart_consum1 = false;
        this.chart_consum2 = false;
        this.chart_consum4 = false;
        this.chart_conn = false;
        this.danger=false;
        this.chart_consum_danger=false;
        this.data = false;
        this.menu=true;
    }
    toogle(str)
    {
        this[str]=this[str]?false:true;
        if(this[str])
        {
        }
        
    }
}

class report_consum
{
    constructor()
    {
        this.level_1=[];
        this.level_2=[];
        this.type_channel = [''];
        this.device = [];
        this.channel = [];
        this.date_range = new date_range();
        this.interval;
        this.good_devices=[];
    }
    check_all_channel_report()
    {
        
        for(var i=0;i<this.channel.length;i++)
        {
            this.channel[i].tick=true;
        }
    }
    none_all_channel_report()
    {
        for(var i=0;i<this.channel.length;i++)
        {
            this.channel[i].tick=false;
        }
    }
    get()
    {
        return this.channel;
    }
        
   
    //преобразовывать
    search_device()
    {
    }
}

class valid_data 
{
    constructor()
    {
        
    }
    valid(str)
    {
        if(str!=undefined&&str.length>0)
        {
            return true;
        }
        else
        {
            return false;
        }
        
    }
    name(str)
    {
        if(this.valid(str)&&str.length<=25)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    comment(str)
    {
        if(this.valid(str)&&str.length<=200)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    address(str)
    {
        if(this.valid(str)&&str.length<=200)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    isInt(str)
    {
        if(this.isNumber(str)&&str % 1 == 0)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    devEui(str)
    {
        return (this.valid(str)&&str.length==16);
    }
    isNumber(str)
    {
        if(str!=undefined&&!isNaN(str))
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    isBool(str)
    {
        if(typeof(str)=="boolean")
        {
            return true;
        }
        else return false;
    }
    isDate(str)
    {
        if(str!=undefined)
        {
            try
            {
                var date = Math.abs(new Date(str).getTime());
                if(date>0&&this.isInt(date))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch(err)
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }
}
class edit_device
{
    constructor(type)
    {
        this.device = new device();
        this.level_1 = new Object();
        this.level_2;
        this.num_channel;
        this.status;
        this.color = new Object();
        this.info_channel;
        this.init_value;
        this.name;
        this.type_channel = new Object();
        this.division;
        this.history;
        this.calib_interval;
        this.model;
        this.serial;
        this.title = 'Создание нового устройства';
        this._init_status=false;
        this.type=type;
    }
    
    valid()
    {
        var valid = new valid_data();
        if(this.type_channel.type==1)
        {
             try
            {
                this.init_value = this.init_value.replace(/,/,'.');
                this.division = this.division.replace(/,/,'.');
            }
            catch(err)
            {
                return false;
            }
            if(valid.devEui(this.device.devEui)&&valid.comment(this.info_channel)&&valid.isInt(this.type_channel.id)&&valid.isNumber(this.division)&&valid.isNumber(this.init_value)&&valid.isDate(this.last_date)&&valid.name(this.level_1.name_level_1)&&valid.name(this.level_2)&&valid.name(this.name)&&valid.address(this.level_1.address_level_1)&&valid.isInt(this.num_channel)&&valid.isInt(this.status)&&valid.isInt(this.color.id)&&valid.isInt(this.calib_interval))
            {
                return true;
            }
            else
            {
                return false;
            }
        }else if(this.type_channel.type==2)
        {
            if(valid.devEui(this.device.devEui)&&valid.comment(this.info_channel)&&valid.isInt(this.type_channel.id)&&valid.name(this.level_1.name_level_1)&&valid.name(this.level_2)&&valid.name(this.name)&&valid.address(this.level_1.address_level_1)&&valid.isInt(this.num_channel)&&valid.isInt(this.status)&&valid.isInt(this.color.id))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }
    refresh()
    {
        try{
            if(!this.level_1.name_level_1.name_level_1||this.level_1.name_level_1.name_level_1==undefined)
            {
                return true;
            }
            else
            {
               if(this.level_1.name_level_1.address_level_1&&this.level_1.name_level_1.address_level_1!=undefined)
                {
                    this.level_1.address_level_1=this.level_1.name_level_1.address_level_1;
                }
                this.level_1.name_level_1=this.level_1.name_level_1.name_level_1;
            }
        }
        catch (err)
        {
            return false;
        }
    }
    init()
    {
        if(!this._init_status)
        {
            this.device = new device();
            this.level_1.address_level_1 = '';
            this.level_1.name_level_1 = '';
            this.level_2 = '';
            this.num_channel = '';
            this.status = '';
            this.color = '';
            this.info_channel = '';
            this.init_value = '';
            this.name = '';
            this.type_channel = '';
            this.division = '';
            this.history = '';
            this.calib_interval='';
            this.model='';
            this.serial='';
            this._init_status=true
        }
        return true;
    }
}
class type_device
{
    constructor(arr_type)
    {
        this.list = arr_type;
    }
    //Поиск типа по id
    get_type_device(id){
        try
        {
            for(var i =0;i<this.list.length;i++)
           {
               if(this.list[i].id==id)
               {
                   return this.list[i];
               }
           }
           return false;
        }
        catch (err)
        {
            return false;
        }
    };
}
class type_channels
{
    constructor(arr_type)
    {
        this.list = arr_type;
    }
    //Поиск типа по id
    get_type_channel(id){
        try
        {
            for(var i =0;i<this.list.length;i++)
           {
               if(this.list[i].id==id)
               {
                   return this.list[i];
               }
           }
           return false;
        }
        catch (err)
        {
            return false;
        }
    };
}
class status_channel_list
{
    constructor(list)
    {
        this.list = list;
    }
    get_status(id)
   {
       try
       {
        for(var i =0;i<this.list.length;i++)
        {
            if(this.list[i].id==id)
            {
                return this.list[i].name;
            }
        }
        return "-";
       }
        catch (err)
        {
            return false;
        }
   };
}
class color_list
{
    constructor(list)
    {
        this.list = list;
    }
    get_color(id)
   {
       try
       {
        for(var i =0;i<this.list.length;i++)
        {
            if(this.list[i].id==id)
            {
                return this.list[i].hex;
            }
        }
        return "transparent";
       }
        catch (err)
        {
            return false;
        }
   };
   get_full_color(id)
   {
        try
       {
        for(var i =0;i<this.list.length;i++)
        {
            if(this.list[i].id==id)
            {
                return this.list[i];
            }
        }
        return "transparent";
       }
        catch (err)
        {
            return false;
        }
   }
  
}
class channel
{
    constructor(address_level_1,name_level_1,level_2,name,num_channel,status,color,info_channel,init_value,last_date,type_channel,history,division,calib_interval,model,serial)
    {
       this.address_level_1 =address_level_1;
       this.name_level_1 =name_level_1;
       this.level_2 =level_2;
       this.name =name;
       this.num_channel =num_channel;
       this.status =status;
       this.color =color;
       this.info_channel =info_channel;
       this.init_value =init_value;
       this.last_date =last_date;
       this.calib_interval=calib_interval;
       this.model=model;
       this.serial=serial;
       this.type_channel =type_channel;
       this.history =history;
       this.temp_history = new Object();
       this.division =division;
       this.statistics=new Statistic();
       this.danger=false;
    }
    clear_history()
    {
    }
    edit(address_level_1,name_level_1,level_2,name,status,color,info_channel,init_value,last_date,type_channel,division,calib_interval,model,serial)
    {
       this.address_level_1 =address_level_1;
       this.name_level_1 =name_level_1;
       this.level_2 =level_2;
       this.name =name;
       this.status =status;
       this.color =color;
       this.info_channel =info_channel;
       this.init_value =init_value;
       this.last_date =last_date;
       this.calib_interval=calib_interval;
       this.model=model;
       this.serial=serial;
       this.type_channel =type_channel;
       this.division =division;
    }
}
class date_range
{
    constructor()
    {
        this.start;
        this.end;
    }
     //Находится ли дата в пределе заданного периода
    compare_unix(date)
    {
        return (date>this.start&&date<this.end)?true:false;  
    }
    compare(date)
    {
        return (date>(this.start*1000)&&date<(this.end*1000))?true:false;  
    }
    compare_full(history,date_range)
    {
        return (history.time>date_range.start&&history.time<date_range.end)?true:false;  
    }
}
class Statistic
{
    constructor()
    {
       this.sum_sensor='-';
       this.chart =[];
       this.chart_temperature =[];
       this.rssi =[];
       this.snr =[];
       this.date =[];
       
       this.consumed = 0;
       this.avr_snr=0;
       this.avr_rssi=0;
       this.fcnt=0;
       this.last_time =0;
       this.last_chart =0;
       this.last_fcnt =0;
       this.last_sensor =0;
       this.start_sensor=0;
       this.end_sensor=0;
       this.arr_date =[];
       this.arr_rssi = [];
       this.connect = [];
       this.arr_snr = [];
       this.type_channel =0;
       this.arr_value =[];
       this.count_danger=0;
       this.count_danger_full=0;
    }
  
}
class Logs
{
    constructor()
    {
        this.list=[];
        this.full_list=[];
    }
    set_log(event,device,mess)
    {
        var newlog={
                mess:mess,
                event:event,
                device:device,
                time:new Date().getTime(),
                time_ru:moment().format('LTS').replace(',',' ')
            };
        if(this.list.length>=10)
        {
            this.list.splice(0,1);
        }
        
        this.list.push(newlog);
        this.full_list.push(newlog);
    }
    
}
class Devices 
{
    constructor()
    {
        this.devices_list=[];
        this.full_devices_list=[];
        this.select_channel_temp=new Object();
        this.select_device_devEui='';//Выбранное устройство
        this.select_device_channel='';//Выбранный канал
        this.all_channel_list=[];
        this.history_lite = [];
    }
    delete_device(devEui)
    {
        for(var i = 0; i<this.devices_list.length;i++)
       {
           if(this.devices_list[i].devEui==devEui)
           {
                this.devices_list.splice(i,1);
           }
       }
       return false;
    }
    reload_all_channel_list()
    {
        var temp=[];
        for(var i =0; i<this.devices_list.length;i++)
        {
            for(var j=0;j<this.devices_list[i].channels.length;j++)
            {
                if(this.devices_list[i].channels[j].name)
                {
                    var tempObj = new Object();
                    tempObj.devEui = this.devices_list[i].devEui;
                    tempObj.channel=this.devices_list[i].channels[j];
                    temp.push(tempObj);
                }
            }
        }
        this.all_channel_list=temp;
    }
    get_editDevice(device,num,color,dev_type)
    {
        var editDevice = new edit_device();
        var channel = this.get_channel(device.devEui,num);
        editDevice.name=channel.name;
        editDevice.device = device;
        editDevice.level_1.address_level_1 = channel.address_level_1;
        editDevice.level_1.name_level_1 = channel.name_level_1;
        editDevice.level_2 = channel.level_2;
        editDevice.name = channel.name;
        editDevice.num_channel = channel.num_channel;
        editDevice.status = channel.status;
        editDevice.color = color;
        editDevice.info_channel = channel.info_channel;
        editDevice.init_value = channel.init_value;
        editDevice.calib_interval = channel.calib_interval;
        editDevice.model = channel.model;
        editDevice.serial = channel.serial;
        editDevice.division = channel.division;
        editDevice.type_channel = dev_type;
        editDevice.last_date = new Date(moment(channel.last_date).format('YYYY-MM-DD'));
        editDevice.history = channel.history;
        return editDevice;
    }
    add_history_lite(json,index,date)
    {
        var newData = new data_lora();
        if(newData.set_data(json.data))
        {
            if(newData.type_package==1)
            {
                for(var key in this.devices_list[index].channels)
                {
                    try{
                        var res  = new cell_history_lite(json,newData,(parseInt(key)+1),this.devices_list[index].devEui);
                        if(res)
                        {
                               this.history_lite.push(res);
                        }
                    }
                    catch(err)
                    {
                        console.log(err);
                    }
                }
                return newData;
            }
            else if(newData.type_package==2)
            {
                for(var key in this.devices_list[index].channels)
                {
                    try{
                       var res  = new cell_history_lite(json,newData,(parseInt(key)+1),this.devices_list[index].devEui);
                        if(res)
                        {
                            this.history_lite.push(res);
                        }
                    }
                    catch(err)
                    {
                        
                        console.log(err);
                    }
                }
                return newData;
            }
            else if(newData.type_package==3)
            {
                for(var key in newData.archive)
                {
                    newData.sensors['sensor_'+(newData.num_channel)]=newData.archive[key][0];
                    newData.time=newData.archive[key][1];
                    try
                    {
                        var res  = new cell_history_lite(json,newData,newData.num_channel,this.devices_list[index].devEui);
                        if(res)
                        {
                            this.history_lite.push(res);
                        }
                    }
                       catch(err)
                    {
                        console.log(err);
                    }
                }
                return newData;
            }
            else
            {
                return false;
                console.log('Не умею пока парсить пакет такого типа, но он считан');
            }
        }
        else
        {
            return false
        }
    }
    add_history(json,index,date)
    {   
        var newData = new data_lora();
        if(newData.set_data(json.data))
        {
            if(newData.type_package==1)
            {
                for(var key in this.devices_list[index].channels)
                {
                    try{
                        var res  = new cell_history(json,newData,(parseInt(key)+1));
                        if(res)
                        {
                            if(res.time!=undefined)
                            {
                                if(this.devices_list[index].channels[key].temp_history[res.time]==undefined||!this.devices_list[index].channels[key].temp_history[res.time])
                                {
                                   this.devices_list[index].channels[key].temp_history[res.time]=true;
                                   this.devices_list[index].channels[key].history.push(res);
                                }
                            }
                            else
                            {
                                this.devices_list[index].channels[key].history.push(res);
                            }       
                        }
                    }
                    catch(err)
                    {
                        console.log(err);
                    }
                }
                return newData;
            }
            else if(newData.type_package==2)
            {
                for(var key in this.devices_list[index].channels)
                {
                    try{
                       var res  = new cell_history(json,newData,(parseInt(key)+1));
                        if(res)
                        {
                            if(res.time!=undefined)
                            {
                                if(this.devices_list[index].channels[key].temp_history[res.time]==undefined||!this.devices_list[index].channels[key].temp_history[res.time])
                                {
                                   this.devices_list[index].channels[key].temp_history[res.time]=true;
                                   this.devices_list[index].channels[key].history.push(res);
                                }
                            }
                            else
                            {
                                this.devices_list[index].channels[key].history.push(res);
                            }
                        }
                    }
                    catch(err)
                    {
                        console.log(err);
                    }
                }
                return newData;
            }
            else if(newData.type_package==3)
            {
                for(var key in newData.archive)
                {
                    newData.sensors['sensor_'+(newData.num_channel)]=newData.archive[key][0];
                    newData.time=newData.archive[key][1];
                    try
                    {
                        var res  = new cell_history(json,newData,newData.num_channel);
                        if(res)
                        {
                            if(res.time!=undefined)
                            {
                                if(this.devices_list[index].channels[newData.num_channel].temp_history[res.time]==undefined||!this.devices_list[index].channels[newData.num_channel].temp_history[res.time])
                                {
                                   this.devices_list[index].channels[newData.num_channel].temp_history[res.time]=true;
                                   this.devices_list[index].channels[newData.num_channel].history.push(res);
                                }
                            }
                            else
                            {
                                this.devices_list[index].channels[newData.num_channel].history.push(res);
                            }
                        }
                    }
                       catch(err)
                    {
                        console.log(err);
                    }
                }
                return newData;
            }
            else
            {
                return false;
                //to4ka
                console.log('Не умею пока парсить пакет такого типа, но он считан');
            }
        }
        else
        {
            return false
        }
    };
    channels_search(num_channel,devEui,level_1,level_2)
    {
        for(var i=0;i< this.devices_list.length;i++)
        {
            if(this.devices_list[i].devEui==devEui)
            {
                for(var j=0;j< this.devices_list[i].channels.length;j++)
                {
                    if(this.devices_list[i].channels[j].address_level_1==level_1.address_level_1&&this.devices_list[i].channels[j].name_level_1==level_1.name_level_1&&this.devices_list[i].channels[j].level_2==level_2&&this.devices_list[i].channels[j].num_channel==num_channel)
                    {
                        return true;
                    }
                }
            }
        }
        return false;
    };
    device_search(devEui,level_1,level_2)
    {
        for(var i=0;i< this.devices_list.length;i++)
        {
            for(var j=0;j< this.devices_list[i].channels.length;j++)
            {
                if(this.devices_list[i].channels[j].name_level_1==level_1.name_level_1&&this.devices_list[i].channels[j].address_level_1==level_1.address_level_1&&this.devices_list[i].channels[j].level_2==level_2)
                {
                    return true;
                }
            }
        }
        return false;
    };
    level_2_search(level_2,level_1)
    {
        for(var i=0;i< this.devices_list.length;i++)
        {
            for(var j=0;j< this.devices_list[i].channels.length;j++)
            {
                if(this.devices_list[i].channels[j].name_level_1==level_1.name_level_1&&this.devices_list[i].channels[j].address_level_1==level_1.address_level_1&&this.devices_list[i].channels[j].level_2==level_2)
                {
                    return this.devices_list[i].channels[j];
                }
            }
        }
        return false;
    };
    level_1_search(name,address)
    {
        for(var i=0;i< this.devices_list.length;i++)
        {
            for(var j=0;j< this.devices_list[i].channels.length;j++)
            {
                if(this.devices_list[i].channels[j].name_level_1==name&&this.devices_list[i].channels[j].address_level_1==address)
                {
                    return this.devices_list[i].channels[j];
                }
            }
        }
        return false;
    };
    search_channel_device_list(num,devEui)
    {
        num--;
        for(var i=0;i< this.devices_list.length;i++)
        {
                if(devEui==this.devices_list[i].devEui&&this.devices_list[i].channels[num]!=undefined&&this.devices_list[i].channels[num].status!=undefined&&this.devices_list[i].channels[num].status)
                {
                   return true;
                }
        }
        return false;
    };
    select_channel(devEui,num_channel)
    {
        try
        {
            for(var i=0;i< this.devices_list.length;i++)
            {
                if(this.devices_list[i].devEui==devEui)
                {
                    for(var j=0;j< this.devices_list[i].channels.length;j++)
                    {
                        if(this.devices_list[i].channels[j].num_channel==num_channel)
                        {
                            this.select_device_devEui=devEui;
                            this.select_device_channel=num_channel;
                            this.select_channel_temp = this.devices_list[i].channels[j];
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        catch(err)
        {
            return false;
        }
    }
    get_active_channel(devEui)
   {
       var channels = this.get_device(devEui).channels;
       var resArr = [];
       for(var i =0;i<channels.length;i++)
       {
           if(channels[i].status!=undefined&&channels[i].status==1)
           {
               resArr.push(channels[i].name);
           }
       }
       return resArr;
   };
    //Вернуть устройство по devEui
    get_device(devEui)
   {
       for(var i = 0; i<this.devices_list.length;i++)
       {
           if(this.devices_list[i].devEui==devEui)
           {
               return this.devices_list[i];
           }
       }
       return false;
   }
   reconnect_device(device)
   {
       for(var i = 0; i<this.devices_list.length;i++)
       {
           if(this.devices_list[i].devEui==device.devEui)
           {
               this.devices_list[i]=device;
               return true;
           }
       }
       return false;
   }
   clean_tick_device_original()
   {
       for(var i = 0; i<this.full_devices_list.length;i++)
       {
            this.full_devices_list[i].tick=false;
       }
   }
   get_device_original(devEui)
   {
       for(var i = 0; i<this.full_devices_list.length;i++)
       {
           if(this.full_devices_list[i].devEui==devEui)
           {
               return this.full_devices_list[i];
           }
       }
   }
   get_count_channel()
   {
       var count_channel=0;
       for(var i = 0; i< this.devices_list.length;i++)
       {
           for( var j = 0 ; j<this.devices_list[i].channels.length;j++)
           {
               if(this.devices_list[i].channels[j].type_channel != undefined && this.devices_list[i].channels[j].num_channel !=undefined)
               {
                   count_channel++
               }
           }
       }
       return count_channel;
   }
   //вернуть канал по devEui и номеру канала
   get_channel(devEui,channel)
   {
       try
       {
       for(var i = 0; i<this.devices_list.length;i++)
       {
           if(this.devices_list[i].devEui==devEui)
           {
                for(var j = 0; j<this.devices_list[i].channels.length;j++)
                {
                    if(this.devices_list[i].channels[j].num_channel==channel)
                    {
                        return this.devices_list[i].channels[j];
                    }
                }
           }
       }
        }
        catch (err)
        {
            return [];
        }
   }
   get_select_channel()
   {
       try
       {
       for(var i = 0; i<this.devices_list.length;i++)
       {
           if(this.devices_list[i].devEui==this.select_device_devEui)
           {
                for(var j = 0; j<this.devices_list[i].channels.length;j++)
                {
                    if(this.devices_list[i].channels[j].num_channel==this.select_device_channel)
                    {
                        return this.devices_list[i].channels[j];
                    }
                }
           }
       }
        }
        catch (err)
        {
            return [];
        }
   }
   get_history(channel,date)
   {
       try
       {
        var history = channel.history;
        var temp=[];
        for(var i = 0; i <history.length;i++)
        {
            if(channel.type_channel==6)
            {
                if(history[i].ts>date.start*1000&&history[i].ts<date.end*1000)
                {
                    temp.push(history[i]);
                }
            }
            else
            {
               if(history[i].time>date.start&&history[i].time<date.end)
                {
                    temp.push(history[i]);
                } 
            }
        }
        return temp;
       }
       catch(err)
       {
           return []
       }
   }
   get_history_lite(devEui,channel,date)
   {
       try
       {
        var temp=[];
        for(var i = 0; i <this.history_lite.length;i++)
        {
            if(this.history_lite[i].time>date.start&&this.history_lite[i].time<date.end&&this.history_lite[i].devEui==devEui&&this.history_lite[i].num_channel==channel)
            {
                temp.push(this.history_lite[i]);
                
            }
        }
        return temp;
       }
       catch(err)
       {
           return []
       }
   }
   get_history_lite_ts(devEui,channel,date)
   {
       try
       {
        var temp=[];
        for(var i = 0; i <this.history_lite.length;i++)
        {
            if(this.history_lite[i].ts>(date.start*1000)&&this.history_lite[i].ts<(date.end*1000)&&this.history_lite[i].devEui==devEui&&this.history_lite[i].num_channel==channel)
            {
                temp.push(this.history_lite[i]);
                
            }
        }
        return temp;
       }
       catch(err)
       {
           return []
       }
   }
   get_history_select_channel(date)
   {
       
        var channel = this.get_select_channel()
        return this.get_history(channel,date);    
   }
   get_history_last(history)
   {
       try
       {
       var temp = new Object();
       temp.time = 0;
       temp.index=0;
       
       for(var i=0;i<history.length ;i++)
       {
           if(history[i].time>temp.time) 
           {
               temp.time=history[i].time;
               temp.index=i;
           }
       }
        
       return history[temp.index];
        }
        catch (err)
        {
            return new cell_history();
        }
   }
   
   //получение статистики
   get_statistics(date)
   {
       this.reload_all_channel_list();
       try
       { 
           var channel = this.get_channel(this.select_device_devEui,this.select_device_channel);
           var minDate = 9999999999;
           var maxDate = 0;
           var minS = 0;
           var maxS=0;
           var fcnt=0;
           var snr = new Object();
           snr.val = 0;
           snr.count=0;
           var rssi = new Object();
           rssi.val = 0;
           rssi.count=0;
           var connect = [];
           var arr_date = [];
           var arr_rssi = [];
           var arr_snr = [];
           var tempArr =[];
           var arr_value=[];
           var temp =new Object();
           var my_converter = new vega_converter();
           channel.statistics.count_danger = 0;
           channel.statistics.count_danger_full = 0;
           channel.statistics.chart=[];
           channel.statistics.chart_temperature=[];
           channel.statistics.last_ts=0;
          for(var i = 0; i< channel.history.length;i++)
         {
            if(channel.history[i].time>channel.statistics.last_time&&channel.history[i].type==1)
            {
                channel.statistics.last_temperature=channel.history[i].temperature;
                channel.statistics.last_charge=channel.history[i].charge;
                channel.statistics.last_time=channel.history[i].time;
                channel.statistics.last_fcnt=channel.history[i].fcnt;
                channel.statistics.last_sensor= my_converter.round_size((((this.select_channel_temp.init_value*this.select_channel_temp.division)+channel.history[i].sensor)/this.select_channel_temp.division),2);  
                if(channel.history[i].ts>channel.statistics.last_ts)
                {
                    channel.statistics.last_ts=channel.history[i].ts;
                }
            } else if(channel.history[i].type==2)
            {
                channel.statistics.count_danger_full++;
                if(channel.history[i].ts>channel.statistics.last_ts)
                {
                    channel.statistics.last_ts=channel.history[i].ts;
                    channel.statistics.last_charge=channel.history[i].charge;
                }
            }
             if(channel.history[i].time>date.start&&channel.history[i].time<date.end&&channel.history[i].type==1)
             {
                 if(channel.history[i].type==1){
                     channel.statistics.chart.push([convert_time(channel.history[i].time)*1000,channel.history[i].sensor]);
                     
                     if(channel.history[i].time<minDate)
                    {
                        minDate = channel.history[i].time;
                        minS = channel.history[i].sensor;
                    }
                    if(channel.history[i].time>maxDate)
                    {
                        maxDate = channel.history[i].time;
                        maxS = channel.history[i].sensor;
                    }
                    if(channel.history[i].time!=undefined&&channel.history[i].sensor!=undefined)
                    {
                        tempArr.push([channel.history[i].time,channel.history[i].sensor]);
                        temp[channel.history[i].time]=channel.history[i].sensor;
                    }
                    else if(channel.history[i].time!=undefined)
                    {
                        console.log('Error 1294');
                    }
                 }
                 channel.statistics.chart_temperature.push([convert_time(channel.history[i].time)*1000,channel.history[i].temperature]);
             } else if(channel.history[i].type==2&&channel.history[i].ts>(date.start*1000)&&channel.history[i].ts<(date.end*1000)&&channel.history[i].time==undefined)
            {
               channel.statistics.count_danger++;
               arr_value.push([channel.history[i].ts,1]);
            }
             if(channel.history[i].ts>(date.start*1000)&&channel.history[i].ts<(date.end*1000))
            {
                 connect.push({date: channel.history[i].ts,rssi: my_converter.round_size(channel.history[i].rssi,2),snr:my_converter.round_size(channel.history[i].snr,2)});
                 
                 arr_date.push(moment(channel.history[i].ts).format('LLL').replace(',',' '));
                 arr_rssi.push(my_converter.round_size(channel.history[i].rssi,2));
                 arr_snr.push(my_converter.round_size(channel.history[i].snr,2));
                 snr.val+=channel.history[i].snr;snr.count++;
                 rssi.val+=channel.history[i].rssi;rssi.count++;  
            }
         }
         if(channel.type_channel==6)
         {
             
         }
         else{
            fcnt = arr_date.length;
            var tempData = [];
            var tempTime =minDate;
            var block = 0;
            while(tempTime<=maxDate)
            {
                if(temp[tempTime]!=undefined&&temp[tempTime+3600]!=undefined)
                {
                    try{
                          var resultV=temp[tempTime+3600]-temp[tempTime];
                          if(resultV>0)
                          {
                               tempData.push([(convert_time(tempTime)+3600)*1000,resultV]);  
                          }
                      }
                      catch(err)
                      {
                          tempData.push([(convert_time(tempTime)+3600)*1000,0]);
                      }
                }
                else if((convert_time(tempTime)+3600)*1000<=new Date().getTime())
                {
                    tempData.push([(convert_time(tempTime)+3600)*1000,0]);
                }
                tempTime=tempTime+3600;
            }    
            for(var i =tempArr.length-1;i>=0;i--)
            {
                if(tempArr[i][0]>=block)
                {
                 var temp_next = tempArr[i][0]+3600;
                 if(temp[temp_next]!=undefined)
                 {
                     if((temp_next-block)%3600==0||block==0)
                     {
                       arr_value.push([(convert_time(temp_next))*1000,temp[temp_next]-tempArr[i][1]]);
                       block = temp_next;
                       delete temp[temp_next];
                     }
                 }
                 else
                 {
                      arr_value.push([convert_time(temp_next)*1000,0]);
                      block = temp_next;
                 }
                }
            }
         arr_value = tempData;
         channel.statistics.chart.sort(function(a,b){
             return a[0]-b[0];
         });
         
         
         }
         arr_value.sort(function(a,b){
             return a[0]-b[0];
         });
         channel.statistics.chart_temperature.sort(function(a,b){
             return a[0]-b[0];
         });
         channel.statistics.last_time_rus=moment.unix(channel.statistics.last_time).format('DD.MM.YY HH:mm');
         channel.statistics.start_sensor = my_converter.round_size((((this.select_channel_temp.init_value*this.select_channel_temp.division)+minS)/this.select_channel_temp.division),2);
         channel.statistics.end_sensor = my_converter.round_size((((this.select_channel_temp.init_value*this.select_channel_temp.division)+maxS)/this.select_channel_temp.division),2);
         channel.statistics.fcnt = fcnt;
         channel.statistics.avr_snr = my_converter.round_size((snr.val/snr.count),2);
         channel.statistics.avr_rssi = my_converter.round_size((rssi.val/rssi.count),2);
         channel.statistics.consumed = my_converter.round_size(((maxS-minS)/this.select_channel_temp.division),2);
         channel.statistics.arr_date = arr_date;
         channel.statistics.arr_rssi = arr_rssi;
         channel.statistics.arr_snr = arr_snr;
         channel.statistics.connect = connect;
         channel.statistics.arr_value = arr_value;
         channel.statistics.type_channel = channel.type_channel;
       }
        catch (err)
        {
            return false;
        }
   }
}
class cell_history_lite
{
    constructor(mess,data,num_sensor,devEui)
    {
        this.ts=mess.ts;
        this.ack=mess.ack;
        this.fcnt=mess.fcnt;
        this.port=mess.port;
        this.freq=mess.freq;
        this.dr=mess.dr;
        this.temperature=data.temperature;
        this.rssi=mess.rssi;
        this.snr=mess.snr;
        this.charge=data.charge;
        this.switch_device=data.switch_device;
        this.time=data.time;
        this.sensor=data.sensors['sensor_'+num_sensor];
        this.type = data.type_package;
        this.devEui = devEui;
        this.num_channel=num_sensor;
    }
    get_time()
    {
        return moment.unix(this.time).format('LLL').replace(',','');
    }
    get_ts()
    {
        return moment(this.ts).format('LLL').replace(',','');
    }
    get_value(init_val,division)
    {
        var my_convert =  new vega_converter();
        return my_convert.round_size(((init_val*division+this.sensor)/division),2);
    }
}
class cell_history
{
    constructor(mess,data,num_sensor)
    {
        this.ts=mess.ts;
        this.ack=mess.ack;
        this.fcnt=mess.fcnt;
        this.port=mess.port;
        this.freq=mess.freq;
        this.dr=mess.dr;
        this.temperature=data.temperature;
        this.rssi=mess.rssi;
        this.snr=mess.snr;
        this.charge=data.charge;
        this.switch_device=data.switch_device;
        this.time=data.time;
        this.sensor=data.sensors['sensor_'+num_sensor];
        this.type = data.type_package;
    }
    get_time()
    {
        return moment.unix(this.time).format('LLL').replace(',','');
    }
    get_ts()
    {
        return moment(this.ts).format('LLL').replace(',','');
    }
    get_value(init_val,division)
    {
        var my_convert =  new vega_converter();
        return my_convert.round_size(((init_val*division+this.sensor)/division),2);
    }
}
class data_lora
{
    constructor()
    {
        this.type_package;
        this.comment;
        this.hex;
        this.hex_array;
        this.charge;
        this.switch_device=[];
        this.time;
        this.temperature;
        this.sensors=new Object();
        this.num_channel = 0;
        this.count =0;
        this.type_archive;
        this.last_time;
        this.archive=[];
    }
    _set_last_time()
    {
        try
        {
            var time = this.hex_array[9].toString()+this.hex_array[8].toString()+this.hex_array[7].toString()+this.hex_array[6].toString();
            this.last_time = parseInt(time,16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_hex(hex)
     {
        this.hex = hex;
        this.hex_array=[];
        for(var i =0;i<this.hex.length-1;i=i+2)
        {
           this.hex_array.push( this.hex.substring(i, i+2)); 
        }
        try
        {
           this.type_package=parseInt(this.hex_array[0],16);
           return true;
        }
        catch(err){
           return false;
        }
    }
    _set_type_archive()
    {
        try
        {
            this.type_archive=parseInt(this.hex_array[5],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_charge()
    {
        try
        {
            this.charge=parseInt(this.hex_array[1],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_num_channel()
    {
        try
        {
            this.num_channel=parseInt(this.hex_array[3],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_count()
    {
        try
        {
            this.count=parseInt(this.hex_array[4],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_temperature()
    {
        try
        {
            this.temperature=parseInt(this.hex_array[7],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_sensors_opt()
    {
        try
        {
            this.sensors.sensor_1=parseInt(this.hex_array[7]+this.hex_array[6]+this.hex_array[5]+this.hex_array[4],16);
            this.sensors.sensor_2=parseInt(this.hex_array[11]+this.hex_array[10]+this.hex_array[9]+this.hex_array[8],16);
            this.sensors.sensor_3=parseInt(this.hex_array[15]+this.hex_array[14]+this.hex_array[13]+this.hex_array[12],16);
            this.sensors.sensor_4=parseInt(this.hex_array[19]+this.hex_array[18]+this.hex_array[17]+this.hex_array[16],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_sensors()
    {
        try
        {
            this.sensors.sensor_1=parseInt(this.hex_array[11]+this.hex_array[10]+this.hex_array[9]+this.hex_array[8],16);
            this.sensors.sensor_2=parseInt(this.hex_array[15]+this.hex_array[14]+this.hex_array[13]+this.hex_array[12],16);
            this.sensors.sensor_3=parseInt(this.hex_array[19]+this.hex_array[18]+this.hex_array[17]+this.hex_array[16],16);
            this.sensors.sensor_4=parseInt(this.hex_array[23]+this.hex_array[22]+this.hex_array[21]+this.hex_array[20],16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_switch_device()
    {
        try
        {
            this.switch_device=parseInt(this.hex_array[2],16).toString(2).split('').reverse().splice(0,6);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
    _set_archive()
    {
       for(var i =10;i<this.hex_array.length-3;i=i+4)
         {
             var time = this.last_time*1000;
             if(this.type_archive==0)
             {
                 time = moment(time).subtract((i-10)/4, 'hour').unix();
             }
             else if(this.type_archive==1)
             {
                 time = moment(time).subtract((i-10)/4, 'day').unix();
             } else if(this.type_archive==2)
             {
                 time = moment(time).subtract((i-10)/4, 'month').unix();
             } else if(this.type_archive==3)
             {
             }
             else 
             {
                 return false;
             }
            this.archive.push([this.hex_array[i+3].toString()+this.hex_array[i+2].toString()+this.hex_array[i+1].toString()+this.hex_array[i].toString(),time]); 
         }
    }
    _set_time()
    {
        try
        {
            var time = this.hex_array[6].toString()+this.hex_array[5].toString()+this.hex_array[4].toString()+this.hex_array[3].toString();
            this.time = parseInt(time,16);
            return true;
        }
        catch(err)
        {
            return false;
        }
    }
     set_package_3()
    {
        if(this._set_charge())
        {
            if(this._set_switch_device())
            {
                if(this._set_num_channel())
                {
                    if(this._set_count())
                    {
                         if(this._set_type_archive())
                         {
                             if(this._set_last_time())
                             {
                                this._set_archive();
                                this.comment=JSON.stringify(this);
                             }
                             else
                             {
                                 return false;
                             }
                         }
                         else
                         {
                               return false;
                         }
                    }
                    else
                    {
                         return false;
                    }             
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
           return false;
        }
        return true;
    }
    set_package_1()
    {
         if(this._set_charge())
         {
             if(this._set_switch_device())
             {
                 if(this._set_time())
                 {
                     if(this._set_temperature())
                     {
                          if(this._set_sensors())
                          {
                               this.comment=JSON.stringify(this);
                          }
                          else
                          {
                                return false;
                          }
                     }
                     else
                     {
                          return false;
                     }             
                 }
                 else
                 {
                     return false;
                 }
             }
             else
             {
                 return false;
             }

         }
         else
         {
            return false;
         }
         return true;
    }
    set_package_2()
    {
         if(this._set_charge())
         {
             if(this._set_switch_device())
             {
                 if(this._set_num_channel())
                 {
                        this.comment=JSON.stringify(this);
                        this._set_sensors_opt();
                 }
                 else
                 {
                     return false;
                 }
             }
             else
             {
                 return false;
             }
         }
         else
         {
            return false;
         }
         return true;
    }
    back_door(text)
    {
        this.comment=text;
        return true;
    }
    set_data(hex)
    {
        if(this._set_hex(hex))
        {
            
             switch(this.type_package) {
                case 1: 
                   return this.set_package_1();
                break;
                case 2:  
                   return this.set_package_2();
                break;
                case 3:  
                   return this.set_package_3();
                break;
                default:
                    return false;
                break;
             }
         }
         else
         {
            return false;
         }
    }
    get_data(){
         var tempObj = new Object();
         switch(this.type_package) {
            case 1: 
                tempObj.type_package=this.type_package; 
                tempObj.charge = this.charge; 
                tempObj.switch_device = this.switch_device;
                tempObj.time = this.time;
                tempObj.temperature = this.temperature;
                tempObj.sensors = this.sensors;
                tempObj.hex = this.hex;
                return tempObj;
            break;
            case 2:  
                tempObj.type_package=this.type_package; 
                tempObj.charge = this.charge; 
                tempObj.switch_device = this.switch_device;
                tempObj.num_channel = this.num_channel;
                tempObj.hex = this.hex;
                return tempObj;
            break;
            case 3:  
                tempObj.type_package=this.type_package; 
                tempObj.charge = this.charge; 
                tempObj.switch_device = this.switch_device;
                tempObj.num_channel = this.num_channel;
                tempObj.count = this.count;
                tempObj.type_archive = this.type_archive;
                tempObj.last_time = this.last_time;
                tempObj.hex = this.hex;
                tempObj.archive = this.archive;
               return tempObj;
            break;
            default:
                return false;
            break;
         }
    }
}
class device 
{
    constructor(){
        this.devEui=0;
        this.device_type=0;
        this.count_channels=0;
        this.trans_period=0;
        this.lat=0;
        this.lon=0;
        this.devName="";
        this.last_data_ts="";
        this.other_info;
        this.channels=[];
    }
    valid(str)
    {
       return str&&str!=undefined&&str.length>0?true:false;
    }
    set_device(obj,count_channels)
    {   
        
        if(this.valid(obj.devEui))
        {
            this.devEui=obj.devEui;
        }
        else{return false;}
        if(this.valid(obj.device_type))
        {
            this.device_type=obj.device_type;
        }
        else{return false;}
        if(count_channels!=undefined&&count_channels>0)
        {
           if(count_channels>50)
           {
               count_channels=50;
           }
            for(var i =0;i<count_channels;i++)
            {
                if(obj['other_info_'+(i+1)]&&obj['other_info_'+(i+1)]!=undefined)
                {
                    try
                    {
                         this.channels[i]=JSON.parse(obj['other_info_'+(i+1)]);
                         this.channels[i].history=[];
                         this.channels[i].statistics=new Statistic();
                    }
                    catch(err)
                    {
                         this.channels[i]=obj['other_info_'+(i+1)];
                         this.channels[i].history=[];
                         this.channels[i].statistics=new Statistic();
                    }
                   
                }
                else
                {
                    this.channels[i]=new Object();
                    this.channels[i].history=[];
                    this.channels[i].statistics=new Statistic();
                    this.channels[i].num_channel=i+1;
                }
                this.channels[i].edit=new channel().edit;
            }
        }
        if(this.valid(obj.trans_period))
        {
            this.trans_period=obj.trans_period;
        }
        if(obj.last_data_ts!=undefined&&obj.last_data_ts>0)
        {
            this.last_data_ts=obj.last_data_ts;
        }
        if(this.valid(obj.devName))
        {
            this.devName=obj.devName;
        }
         if(this.valid(obj.lat))
        {
            this.lat=obj.lat;
        }
        if(this.valid(obj.lon))
        {
            this.lon=obj.lon;
        }
        if(this.valid(obj.other_info))
        {
            try{
                this.other_info=JSON.parse(obj.other_info);
            }
            catch(err)
            {
                
            }
        }
        return this;
    }
    get_json()
    {
        try
        {
            return JSON.stringify(this);
        }
        catch(err)
        {
            return false;
        }
    }
}
class map_nav
{
    constructor()
    {
        this.level_1_list=[];
        this.level_2_list=[];
        this.level_2_filter_list=[];
        this.level_3_list=[];
        this.check_level_1=-1;//Выбранный объект
        this.check_level_2=-1;//Выбранное помещение
        this.history_danger=[];
    }
    //запись в массив истории тут,  и функции поиска по лев 1 лев2  и тд и збс
    set_history_danger(devEui,num,name_level_1,address_level_1,level_2)
    {
        var tempObj = new Object();
        tempObj.devEui = devEui;
        tempObj.num = num;
        tempObj.name_level_1 = name_level_1;
        tempObj.address_level_1 = address_level_1;
        tempObj.level_2 = level_2;
        this.history_danger.push(tempObj);
    }
    get_level_1_danger(name_level_1,address_level_1)
    {
        var countDanger = 0;
        for(var i=0;i< this.history_danger.length;i++)
        {
            if(this.history_danger[i].name_level_1==name_level_1&&this.history_danger[i].address_level_1==address_level_1)
            {
                countDanger++;
            }
        }
        return countDanger;
    }
    get_level_2_danger(level_2,name_level_1,address_level_1)
    {
        var countDanger = 0;
        for(var i=0;i< this.history_danger.length;i++)
        {
            if(this.history_danger[i].level_2==level_2&&this.history_danger[i].name_level_1==name_level_1&&this.history_danger[i].address_level_1==address_level_1)
            {
                countDanger++;
            }
        }
        return countDanger;
    }
    select_check_level_1(level_1)
    {
       
      if(level_1==this.check_level_1)
      {
        this.check_level_1=-1;
      }
      else
      {
          this.check_level_1=level_1;
      }
        this.check_level_2=-1;
    }
    select_check_level_2(level_2)
    {
       if(this.check_level_2==level_2)
       {
           this.check_level_2=-1;
       }
       else{
        this.check_level_2=level_2;}
    }
    set_danger_level_1()
    {
        
    }
    set_level_1(name,address)
    {
        if(name&&name!=undefined&&address&&address!=undefined)
        {
            var temp = new Object();
            temp.name_level_1=name;
            temp.address_level_1=address;
            temp.danger=false;
            for(var i=0;i<this.level_1_list.length;i++)
            {
                if(this.level_1_list[i].name_level_1==name&&this.level_1_list[i].address_level_1==address)
                {
                    return false;
                }
            }
            this.level_1_list.push(temp);
            return true;
        }
    }
    set_level_2(name)
    {
        if(name!=undefined&&name&&this.level_2_list.indexOf(name.toString())==-1)
        {
            this.level_2_list.push(name.toString());
            this.level_2_filter_list.push({name:name.toString(),tick:true});
        }
    }
    set_level_3(name)
    {
        if(name!=undefined&&name&&this.level_3_list.indexOf(name.toString())==-1)
        {
            this.level_3_list.push(name.toString());
        }
    }
}